/**
 */
package ch.hilbri.blackant.model.impl;

import ch.hilbri.blackant.model.BlackAntModel;
import ch.hilbri.blackant.model.CostUnit;
import ch.hilbri.blackant.model.Employee;
import ch.hilbri.blackant.model.ModelPackage;
import ch.hilbri.blackant.model.Project;
import ch.hilbri.blackant.model.ProjectInAcquisition;
import ch.hilbri.blackant.model.Resource;
import ch.hilbri.blackant.model.YearSlice;

import com.google.common.base.Objects;

import com.google.common.collect.Iterables;

import java.lang.reflect.InvocationTargetException;

import java.util.Collection;
import java.util.Date;
import java.util.List;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.ECollections;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.emf.ecore.xcore.lib.XcoreEListExtensions;

import org.eclipse.xtext.xbase.lib.Functions.Function1;

import org.eclipse.xtext.xbase.lib.IterableExtensions;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Black Ant Model</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link ch.hilbri.blackant.model.impl.BlackAntModelImpl#getEmployees <em>Employees</em>}</li>
 *   <li>{@link ch.hilbri.blackant.model.impl.BlackAntModelImpl#getProjects <em>Projects</em>}</li>
 *   <li>{@link ch.hilbri.blackant.model.impl.BlackAntModelImpl#getAcquisitions <em>Acquisitions</em>}</li>
 *   <li>{@link ch.hilbri.blackant.model.impl.BlackAntModelImpl#getCreationDate <em>Creation Date</em>}</li>
 * </ul>
 *
 * @generated
 */
public class BlackAntModelImpl extends MinimalEObjectImpl.Container implements BlackAntModel {
	/**
	 * The cached value of the '{@link #getEmployees() <em>Employees</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEmployees()
	 * @generated
	 * @ordered
	 */
	protected EList<Employee> employees;

	/**
	 * The cached value of the '{@link #getProjects() <em>Projects</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProjects()
	 * @generated
	 * @ordered
	 */
	protected EList<Project> projects;

	/**
	 * The cached value of the '{@link #getAcquisitions() <em>Acquisitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getAcquisitions()
	 * @generated
	 * @ordered
	 */
	protected EList<ProjectInAcquisition> acquisitions;

	/**
	 * The default value of the '{@link #getCreationDate() <em>Creation Date</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCreationDate()
	 * @generated
	 * @ordered
	 */
	protected static final Date CREATION_DATE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getCreationDate() <em>Creation Date</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getCreationDate()
	 * @generated
	 * @ordered
	 */
	protected Date creationDate = CREATION_DATE_EDEFAULT;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BlackAntModelImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ModelPackage.Literals.BLACK_ANT_MODEL;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Employee> getEmployees() {
		if (employees == null) {
			employees = new EObjectContainmentEList<Employee>(Employee.class, this, ModelPackage.BLACK_ANT_MODEL__EMPLOYEES);
		}
		return employees;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Project> getProjects() {
		if (projects == null) {
			projects = new EObjectContainmentEList<Project>(Project.class, this, ModelPackage.BLACK_ANT_MODEL__PROJECTS);
		}
		return projects;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ProjectInAcquisition> getAcquisitions() {
		if (acquisitions == null) {
			acquisitions = new EObjectContainmentEList<ProjectInAcquisition>(ProjectInAcquisition.class, this, ModelPackage.BLACK_ANT_MODEL__ACQUISITIONS);
		}
		return acquisitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Date getCreationDate() {
		return creationDate;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setCreationDate(Date newCreationDate) {
		Date oldCreationDate = creationDate;
		creationDate = newCreationDate;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ModelPackage.BLACK_ANT_MODEL__CREATION_DATE, oldCreationDate, creationDate));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<String> getPlanningYears() {
		final Function1<Project, EList<CostUnit>> _function = new Function1<Project, EList<CostUnit>>() {
			public EList<CostUnit> apply(final Project it) {
				return it.getCostUnits();
			}
		};
		final Function1<CostUnit, EList<YearSlice>> _function_1 = new Function1<CostUnit, EList<YearSlice>>() {
			public EList<YearSlice> apply(final CostUnit it) {
				return it.getYearSlices();
			}
		};
		final Function1<YearSlice, String> _function_2 = new Function1<YearSlice, String>() {
			public String apply(final YearSlice it) {
				return it.getYear();
			}
		};
		return ECollections.<String>toEList(IterableExtensions.<String>sort(IterableExtensions.<String>toList(IterableExtensions.<String>toSet(IterableExtensions.<YearSlice, String>map(Iterables.<YearSlice>concat(IterableExtensions.<CostUnit, EList<YearSlice>>map(Iterables.<CostUnit>concat(XcoreEListExtensions.<Project, EList<CostUnit>>map(this.getProjects(), _function)), _function_1)), _function_2)))));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Employee findEmployeeAbbrv(final String abbrvName) {
		boolean _isNullOrEmpty = IterableExtensions.isNullOrEmpty(this.getEmployees());
		if (_isNullOrEmpty) {
			return null;
		}
		if ((abbrvName == null)) {
			return null;
		}
		if (((!abbrvName.contains(",")) && (abbrvName.split(" ").length == 2))) {
			final String firstName = (abbrvName.split(" ")[0]).trim();
			final String lastName = (abbrvName.split(" ")[1]).trim();
			final Function1<Employee, Boolean> _function = new Function1<Employee, Boolean>() {
				public Boolean apply(final Employee it) {
					return Boolean.valueOf((Objects.equal(it.getLastName(), lastName) && it.getFirstName().startsWith(firstName)));
				}
			};
			final Function1<Employee, String> _function_1 = new Function1<Employee, String>() {
				public String apply(final Employee it) {
					return firstName;
				}
			};
			final Function1<Employee, String> _function_2 = new Function1<Employee, String>() {
				public String apply(final Employee it) {
					return lastName;
				}
			};
			final List<Employee> possibleEmployees = IterableExtensions.<Employee, String>sortBy(IterableExtensions.<Employee, String>sortBy(IterableExtensions.<Employee>filter(this.getEmployees(), _function), _function_1), _function_2);
			boolean _isNullOrEmpty_1 = IterableExtensions.isNullOrEmpty(possibleEmployees);
			if (_isNullOrEmpty_1) {
				return null;
			}
			else {
				return possibleEmployees.get(0);
			}
		}
		int _length = abbrvName.split(",").length;
		boolean _notEquals = (_length != 2);
		if (_notEquals) {
			return null;
		}
		final String lastName_1 = (abbrvName.split(",")[0]).trim();
		final String firstName_1 = (abbrvName.split(",")[1]).trim().replace(".", "");
		final Function1<Employee, Boolean> _function_3 = new Function1<Employee, Boolean>() {
			public Boolean apply(final Employee it) {
				return Boolean.valueOf((Objects.equal(it.getLastName(), lastName_1) && it.getFirstName().startsWith(firstName_1)));
			}
		};
		final Function1<Employee, String> _function_4 = new Function1<Employee, String>() {
			public String apply(final Employee it) {
				return firstName_1;
			}
		};
		final Function1<Employee, String> _function_5 = new Function1<Employee, String>() {
			public String apply(final Employee it) {
				return lastName_1;
			}
		};
		final List<Employee> possibleEmployees_1 = IterableExtensions.<Employee, String>sortBy(IterableExtensions.<Employee, String>sortBy(IterableExtensions.<Employee>filter(this.getEmployees(), _function_3), _function_4), _function_5);
		boolean _isNullOrEmpty_2 = IterableExtensions.isNullOrEmpty(possibleEmployees_1);
		if (_isNullOrEmpty_2) {
			return null;
		}
		else {
			return possibleEmployees_1.get(0);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Employee findEmployeeWithName(final String firstName, final String lastName) {
		boolean _isNullOrEmpty = IterableExtensions.isNullOrEmpty(this.getEmployees());
		if (_isNullOrEmpty) {
			return null;
		}
		if (((firstName == null) || (lastName == null))) {
			return null;
		}
		final Function1<Employee, Boolean> _function = new Function1<Employee, Boolean>() {
			public Boolean apply(final Employee it) {
				return Boolean.valueOf((Objects.equal(it.getLastName(), lastName) && Objects.equal(it.getFirstName(), firstName)));
			}
		};
		final Function1<Employee, String> _function_1 = new Function1<Employee, String>() {
			public String apply(final Employee it) {
				return firstName;
			}
		};
		final Function1<Employee, String> _function_2 = new Function1<Employee, String>() {
			public String apply(final Employee it) {
				return lastName;
			}
		};
		final List<Employee> possibleEmployees = IterableExtensions.<Employee, String>sortBy(IterableExtensions.<Employee, String>sortBy(IterableExtensions.<Employee>filter(this.getEmployees(), _function), _function_1), _function_2);
		boolean _isNullOrEmpty_1 = IterableExtensions.isNullOrEmpty(possibleEmployees);
		if (_isNullOrEmpty_1) {
			return null;
		}
		else {
			return possibleEmployees.get(0);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Employee findEmployeeWithId(final String employeeId) {
		boolean _isNullOrEmpty = IterableExtensions.isNullOrEmpty(this.getEmployees());
		if (_isNullOrEmpty) {
			return null;
		}
		if ((employeeId == null)) {
			return null;
		}
		final Function1<Employee, Boolean> _function = new Function1<Employee, Boolean>() {
			public Boolean apply(final Employee it) {
				String _employeeId = it.getEmployeeId();
				return Boolean.valueOf(Objects.equal(_employeeId, employeeId));
			}
		};
		final Iterable<Employee> possibleEmployees = IterableExtensions.<Employee>filter(this.getEmployees(), _function);
		boolean _isNullOrEmpty_1 = IterableExtensions.isNullOrEmpty(possibleEmployees);
		if (_isNullOrEmpty_1) {
			return null;
		}
		else {
			return IterableExtensions.<Employee>head(possibleEmployees);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public CostUnit findCostUnit(final String identifier) {
		if ((identifier == null)) {
			return null;
		}
		final Function1<Project, EList<CostUnit>> _function = new Function1<Project, EList<CostUnit>>() {
			public EList<CostUnit> apply(final Project it) {
				return it.getCostUnits();
			}
		};
		final Iterable<CostUnit> allCostUnits = Iterables.<CostUnit>concat(XcoreEListExtensions.<Project, EList<CostUnit>>map(this.getProjects(), _function));
		final Function1<CostUnit, Boolean> _function_1 = new Function1<CostUnit, Boolean>() {
			public Boolean apply(final CostUnit it) {
				String _identifier = it.getIdentifier();
				return Boolean.valueOf(Objects.equal(_identifier, identifier));
			}
		};
		final Iterable<CostUnit> suiteableCostUnits = IterableExtensions.<CostUnit>filter(allCostUnits, _function_1);
		boolean _isNullOrEmpty = IterableExtensions.isNullOrEmpty(suiteableCostUnits);
		if (_isNullOrEmpty) {
			return null;
		}
		else {
			return IterableExtensions.<CostUnit>head(suiteableCostUnits);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ProjectInAcquisition findProjectInAcquisition(final String acquisitionId) {
		if ((acquisitionId == null)) {
			return null;
		}
		final Function1<ProjectInAcquisition, Boolean> _function = new Function1<ProjectInAcquisition, Boolean>() {
			public Boolean apply(final ProjectInAcquisition it) {
				String _acquisitionId = it.getAcquisitionId();
				return Boolean.valueOf(Objects.equal(_acquisitionId, acquisitionId));
			}
		};
		final Iterable<ProjectInAcquisition> suitableEntries = IterableExtensions.<ProjectInAcquisition>filter(this.getAcquisitions(), _function);
		boolean _isNullOrEmpty = IterableExtensions.isNullOrEmpty(suitableEntries);
		if (_isNullOrEmpty) {
			return null;
		}
		else {
			return IterableExtensions.<ProjectInAcquisition>head(suitableEntries);
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Resource> getAllResources(final String year) {
		if ((year == null)) {
			return null;
		}
		final Function1<Project, EList<CostUnit>> _function = new Function1<Project, EList<CostUnit>>() {
			public EList<CostUnit> apply(final Project it) {
				return it.getCostUnits();
			}
		};
		final Function1<CostUnit, EList<YearSlice>> _function_1 = new Function1<CostUnit, EList<YearSlice>>() {
			public EList<YearSlice> apply(final CostUnit it) {
				return it.getYearSlices();
			}
		};
		final Function1<YearSlice, Boolean> _function_2 = new Function1<YearSlice, Boolean>() {
			public Boolean apply(final YearSlice it) {
				String _year = it.getYear();
				return Boolean.valueOf(Objects.equal(_year, year));
			}
		};
		final Iterable<YearSlice> yearSlices = IterableExtensions.<YearSlice>filter(Iterables.<YearSlice>concat(IterableExtensions.<CostUnit, EList<YearSlice>>map(Iterables.<CostUnit>concat(XcoreEListExtensions.<Project, EList<CostUnit>>map(this.getProjects(), _function)), _function_1)), _function_2);
		if ((yearSlices != null)) {
			final Function1<YearSlice, EList<Resource>> _function_3 = new Function1<YearSlice, EList<Resource>>() {
				public EList<Resource> apply(final YearSlice it) {
					return it.getResources();
				}
			};
			return ECollections.<Resource>toEList(Iterables.<Resource>concat(IterableExtensions.<YearSlice, EList<Resource>>map(yearSlices, _function_3)));
		}
		else {
			return null;
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CostUnit> getAllCostUnitsFor(final String year, final String departmentName) {
		if (((year == null) || (departmentName == null))) {
			return null;
		}
		final Function1<Project, EList<CostUnit>> _function = new Function1<Project, EList<CostUnit>>() {
			public EList<CostUnit> apply(final Project it) {
				return it.getCostUnits();
			}
		};
		final Function1<CostUnit, EList<YearSlice>> _function_1 = new Function1<CostUnit, EList<YearSlice>>() {
			public EList<YearSlice> apply(final CostUnit it) {
				return it.getYearSlices();
			}
		};
		final Function1<YearSlice, Boolean> _function_2 = new Function1<YearSlice, Boolean>() {
			public Boolean apply(final YearSlice it) {
				return Boolean.valueOf((Objects.equal(it.getYear(), year) && it.hasBudgetPersonnelFullCostsFor(departmentName)));
			}
		};
		final Iterable<YearSlice> yearSlices = IterableExtensions.<YearSlice>filter(Iterables.<YearSlice>concat(IterableExtensions.<CostUnit, EList<YearSlice>>map(Iterables.<CostUnit>concat(XcoreEListExtensions.<Project, EList<CostUnit>>map(this.getProjects(), _function)), _function_1)), _function_2);
		final Function1<YearSlice, CostUnit> _function_3 = new Function1<YearSlice, CostUnit>() {
			public CostUnit apply(final YearSlice it) {
				return it.getCostUnit();
			}
		};
		return ECollections.<CostUnit>toEList(IterableExtensions.<YearSlice, CostUnit>map(yearSlices, _function_3));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<CostUnit> getAllCostUnitsFor(final String departmentName) {
		if ((departmentName == null)) {
			return null;
		}
		final Function1<Project, EList<CostUnit>> _function = new Function1<Project, EList<CostUnit>>() {
			public EList<CostUnit> apply(final Project it) {
				return it.getCostUnits();
			}
		};
		final Function1<CostUnit, EList<YearSlice>> _function_1 = new Function1<CostUnit, EList<YearSlice>>() {
			public EList<YearSlice> apply(final CostUnit it) {
				return it.getYearSlices();
			}
		};
		final Function1<YearSlice, Boolean> _function_2 = new Function1<YearSlice, Boolean>() {
			public Boolean apply(final YearSlice it) {
				return Boolean.valueOf(it.hasBudgetPersonnelFullCostsFor(departmentName));
			}
		};
		final Iterable<YearSlice> yearSlices = IterableExtensions.<YearSlice>filter(Iterables.<YearSlice>concat(IterableExtensions.<CostUnit, EList<YearSlice>>map(Iterables.<CostUnit>concat(XcoreEListExtensions.<Project, EList<CostUnit>>map(this.getProjects(), _function)), _function_1)), _function_2);
		final Function1<YearSlice, CostUnit> _function_3 = new Function1<YearSlice, CostUnit>() {
			public CostUnit apply(final YearSlice it) {
				return it.getCostUnit();
			}
		};
		return ECollections.<CostUnit>toEList(IterableExtensions.<CostUnit>toSet(IterableExtensions.<YearSlice, CostUnit>map(yearSlices, _function_3)));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<YearSlice> getAllYearSlicesFor(final Employee employee, final String year) {
		if (((year == null) || (employee == null))) {
			return null;
		}
		final Function1<Project, EList<CostUnit>> _function = new Function1<Project, EList<CostUnit>>() {
			public EList<CostUnit> apply(final Project it) {
				return it.getCostUnits();
			}
		};
		final Function1<CostUnit, EList<YearSlice>> _function_1 = new Function1<CostUnit, EList<YearSlice>>() {
			public EList<YearSlice> apply(final CostUnit it) {
				return it.getYearSlices();
			}
		};
		final Function1<YearSlice, Boolean> _function_2 = new Function1<YearSlice, Boolean>() {
			public Boolean apply(final YearSlice it) {
				return Boolean.valueOf((Objects.equal(it.getYear(), year) && (!IterableExtensions.isNullOrEmpty(IterableExtensions.<Resource>filter(it.getResources(), new Function1<Resource, Boolean>() {
					public Boolean apply(final Resource it) {
						Employee _employee = it.getEmployee();
						return Boolean.valueOf(Objects.equal(_employee, employee));
					}
				})))));
			}
		};
		final Iterable<YearSlice> yearSlices = IterableExtensions.<YearSlice>filter(Iterables.<YearSlice>concat(IterableExtensions.<CostUnit, EList<YearSlice>>map(Iterables.<CostUnit>concat(XcoreEListExtensions.<Project, EList<CostUnit>>map(this.getProjects(), _function)), _function_1)), _function_2);
		return ECollections.<YearSlice>toEList(IterableExtensions.<YearSlice>toSet(yearSlices));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ModelPackage.BLACK_ANT_MODEL__EMPLOYEES:
				return ((InternalEList<?>)getEmployees()).basicRemove(otherEnd, msgs);
			case ModelPackage.BLACK_ANT_MODEL__PROJECTS:
				return ((InternalEList<?>)getProjects()).basicRemove(otherEnd, msgs);
			case ModelPackage.BLACK_ANT_MODEL__ACQUISITIONS:
				return ((InternalEList<?>)getAcquisitions()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ModelPackage.BLACK_ANT_MODEL__EMPLOYEES:
				return getEmployees();
			case ModelPackage.BLACK_ANT_MODEL__PROJECTS:
				return getProjects();
			case ModelPackage.BLACK_ANT_MODEL__ACQUISITIONS:
				return getAcquisitions();
			case ModelPackage.BLACK_ANT_MODEL__CREATION_DATE:
				return getCreationDate();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ModelPackage.BLACK_ANT_MODEL__EMPLOYEES:
				getEmployees().clear();
				getEmployees().addAll((Collection<? extends Employee>)newValue);
				return;
			case ModelPackage.BLACK_ANT_MODEL__PROJECTS:
				getProjects().clear();
				getProjects().addAll((Collection<? extends Project>)newValue);
				return;
			case ModelPackage.BLACK_ANT_MODEL__ACQUISITIONS:
				getAcquisitions().clear();
				getAcquisitions().addAll((Collection<? extends ProjectInAcquisition>)newValue);
				return;
			case ModelPackage.BLACK_ANT_MODEL__CREATION_DATE:
				setCreationDate((Date)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ModelPackage.BLACK_ANT_MODEL__EMPLOYEES:
				getEmployees().clear();
				return;
			case ModelPackage.BLACK_ANT_MODEL__PROJECTS:
				getProjects().clear();
				return;
			case ModelPackage.BLACK_ANT_MODEL__ACQUISITIONS:
				getAcquisitions().clear();
				return;
			case ModelPackage.BLACK_ANT_MODEL__CREATION_DATE:
				setCreationDate(CREATION_DATE_EDEFAULT);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ModelPackage.BLACK_ANT_MODEL__EMPLOYEES:
				return employees != null && !employees.isEmpty();
			case ModelPackage.BLACK_ANT_MODEL__PROJECTS:
				return projects != null && !projects.isEmpty();
			case ModelPackage.BLACK_ANT_MODEL__ACQUISITIONS:
				return acquisitions != null && !acquisitions.isEmpty();
			case ModelPackage.BLACK_ANT_MODEL__CREATION_DATE:
				return CREATION_DATE_EDEFAULT == null ? creationDate != null : !CREATION_DATE_EDEFAULT.equals(creationDate);
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
		switch (operationID) {
			case ModelPackage.BLACK_ANT_MODEL___GET_PLANNING_YEARS:
				return getPlanningYears();
			case ModelPackage.BLACK_ANT_MODEL___FIND_EMPLOYEE_ABBRV__STRING:
				return findEmployeeAbbrv((String)arguments.get(0));
			case ModelPackage.BLACK_ANT_MODEL___FIND_EMPLOYEE_WITH_NAME__STRING_STRING:
				return findEmployeeWithName((String)arguments.get(0), (String)arguments.get(1));
			case ModelPackage.BLACK_ANT_MODEL___FIND_EMPLOYEE_WITH_ID__STRING:
				return findEmployeeWithId((String)arguments.get(0));
			case ModelPackage.BLACK_ANT_MODEL___FIND_COST_UNIT__STRING:
				return findCostUnit((String)arguments.get(0));
			case ModelPackage.BLACK_ANT_MODEL___FIND_PROJECT_IN_ACQUISITION__STRING:
				return findProjectInAcquisition((String)arguments.get(0));
			case ModelPackage.BLACK_ANT_MODEL___GET_ALL_RESOURCES__STRING:
				return getAllResources((String)arguments.get(0));
			case ModelPackage.BLACK_ANT_MODEL___GET_ALL_COST_UNITS_FOR__STRING_STRING:
				return getAllCostUnitsFor((String)arguments.get(0), (String)arguments.get(1));
			case ModelPackage.BLACK_ANT_MODEL___GET_ALL_COST_UNITS_FOR__STRING:
				return getAllCostUnitsFor((String)arguments.get(0));
			case ModelPackage.BLACK_ANT_MODEL___GET_ALL_YEAR_SLICES_FOR__EMPLOYEE_STRING:
				return getAllYearSlicesFor((Employee)arguments.get(0), (String)arguments.get(1));
		}
		return super.eInvoke(operationID, arguments);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuilder result = new StringBuilder(super.toString());
		result.append(" (creationDate: ");
		result.append(creationDate);
		result.append(')');
		return result.toString();
	}

} //BlackAntModelImpl
